<script setup>
import { computed } from 'vue'
import { useDataLinkStore } from '@/stores/useDataLinkStore'
import ToolChooser from '@/components/ToolChooser.vue'
import DataChooser from '@/components/DataChooser.vue'

const dataLinkStore = useDataLinkStore()
const currentStep = ref('selectConnector')
const selectedTool = ref(null)
const currentDataObjects = ref(null)

// declare prop for v-model attribute
const props = defineProps(['modelValue', 'isaObject', 'investigationId', 'studyId'])
const emit = defineEmits(['update:modelValue'])
const value = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})
watch(value, async (newValue, oldValue) => {
  if(newValue) {
    //dialog is open
    currentStep.value = 'selectConnector'
  }
})

async function onToolSelected(tool) {
    selectedTool.value = tool
    currentStep.value = "chooseDataObject"
}

async function setcurrentStep(step) {
  currentStep.value = step
}

async function onUsedDataObject(usedDataObject) {
  if(props.isaObject.studies) {
    await dataLinkStore.createDataLink(props.isaObject, "investigation", selectedTool.value, usedDataObject)
  }
  else if(props.isaObject.assays) {
    await dataLinkStore.createDataLink(props.isaObject, "study", selectedTool.value, usedDataObject)
  }
  else {
    await dataLinkStore.createDataLink(props.isaObject, "assay" , selectedTool.value, usedDataObject)
  }
    value.value = false
}

</script>

<template>
    <v-dialog
      width="1000"
      v-model="value"
      scrollable
    >
    <v-card>
        <v-card-title>
            Add a Datalink
        </v-card-title>
        <v-card-text style="height: 500px;">
            <v-container class="fill-height">
              
                <ToolChooser connectorType="dataconnector" @toolselected="onToolSelected" v-if="currentStep == 'selectConnector'"/>
                <v-row class="fill-height" v-if="currentStep == 'chooseDataObject'">
                  <DataChooser buttonTitle="Create DataLink" :selectedTool="selectedTool" @currentStep="setcurrentStep" @usedDataObject="onUsedDataObject"/>
                </v-row>
            </v-container>
        </v-card-text>
    </v-card>
    </v-dialog>
</template>

<style>
.skeleton {
  animation: skeleton-loading 1s linear infinite alternate;
}

@keyframes skeleton-loading {
  0% {
    background-color: hsl(200, 20%, 80%);
  }
  100% {
    background-color: hsl(200, 20%, 95%);
  }
}

.skeleton-text {
  width: 100%;
  height: 1.5rem;
  margin-bottom: 0.5rem;
  border-radius: 0.25rem;
}

.skeleton-title {
  width: 50%;
}
</style>
